clear all
PUNTO_A = 0;
PUNTO_B = 0;
PUNTO_C = 1;

% punto (a)
if PUNTO_A 
    A=[5  0 -1 2;  -2 4 1 0; 0 -1 4  -1; 2 0 0 3 ],	
    b=[15 -4 -8 3]';
    x=[3 1 -2 -1]';
end

%punto (b)
if PUNTO_B 
for n=[10]%,100,1000]
    A=diag(ones(n,1)*4)+diag(-ones(n-1,1),1)+diag(-ones(n-1,1),-1)+...
    diag(-ones(n-3,1),3)+diag(-ones(n-3,1),-3);
    % grafico di sparsit di A;
    x=ones(n,1);
    spy(A)
    b=A*x;
end
end

% punto (c)
if PUNTO_C 
 K=[4 -1 0; -1 4 -1; 0 -1 4];
 A=[K -eye(3) zeros(3);-eye(3) K -eye(3); zeros(3) -eye(3) K]
 b=[2 1 2 1 0 1 2 1 2]';
 x=ones(9,1);
 % grafico di sparsit di A;
 spy(A)
end

%% Risoluzione sistema lineare con metodo iterativo
[n,n]=size(A);
x0=zeros(n,1);
tol=1e-3;
Maxit=400;
if (norm(A-A')>1e-10) || (min(eig(A))<=0) % Controllo simmetria e definita positiva
        disp('Attenzione: no pcg poich non  simmetrica def.pos. ')
        [x_gs,its_gs]=g_seidel(A,b,x0,tol,Maxit)
        omega=1.2;
        [x_sor,its_sor]=sor(A,b,x0,omega,tol,Maxit)
        fprintf('its_gs=%d its_sor=%d \n',its_gs ,its_sor)

        fprintf('\n x_gs      x_sor \n')
        fprintf('-------------------------\n')
        for i=1:n
            fprintf('%2.4f    %2.4f \n',x_gs(i),x_sor(i));
        end
        % calcolo errore tra soluzione esatta e soluzione ottenuta con 
        % il metodo iterativo
        errgs = norm(x-x_gs);
        errsor = norm(x-x_sor);
        fprintf('\n Errore \n')
        fprintf('%2.7e    %2.7e \n', errgs, errsor);
else
        %[x_pcg,its_pcg]=pcg(A,b,tol,Maxit); %built-in function di MATLAB
        [x_pcg,its_pcg]=conj_grad(A,b,x0,tol,Maxit);
        [x_gs,its_gs]=g_seidel(A,b,x0,tol,Maxit);
        omega=1.5;
        [x_sor,its_sor]=sor(A,b,x0,omega,tol,Maxit);
        fprintf('its_pcg=%d  its_gs=%d its_sor=%d \n',its_pcg ,its_gs ,its_sor)

        fprintf('x_pcg      x_gs      x_sor \n')
        fprintf('-------------------------\n')
        for i=1:n
            fprintf('%2.4f     %2.4f    %2.4f \n',x_pcg(i), x_gs(i),x_sor(i));
        end
        % calcolo errore tra soluzione esatta e soluzione ottenuta con 
        % il metodo iterativo
        errpcg = norm(x-x_pcg);
        errgs = norm(x-x_gs);
        errsor = norm(x-x_sor);
        fprintf('\n Errore \n')
        fprintf('%2.7e     %2.7e    %2.7e \n',errpcg, errgs, errsor);
end


