clear all;close all;
m=400; n=22;
%m=1600; n=42;
% Costruire A
G=numgrid('S',n); 
A=delsq(G);
%A matrice mxm con m = (n-2)^2
b=A*ones(m,1);
spy(A)


fprintf('the condition number of the matrix A is %f \n',condest(A))

% Costruire il precondizionatore  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PUNTO a)
%[R]=cholinc(A,'0');
%[R]= ichol(A,struct('type','ict','droptol',1e-02);
%  The 'nofill' variant performs incomplete Cholesky with zero-fill (IC(0)).
%  The 'ict' variant performs incomplete Cholesky with threshold dropping
%  (ICT).  The default value is 'nofill'.
[R]= ichol(A,struct('type','nofill'));
M = R'*R;

%PUNTO b)
%M=diag(diag(A));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf(' the condition number of the matrix  M^-1 A is %f \n',condest(inv(M)*A))

%% risolvi il sistema lineare senza e con precondizionatore %%%%%%%%%
[X,FLAG,RELRES,ITER] = pcg(A,b,1e-10,200);
if FLAG==0 
    disp('Iterazioni senza precondizionatore '); disp(ITER)
elseif FLAG==1
    disp(' pcg without precond. does not converge in 200 iterations ')
end
[X,FLAG,RELRES,ITER] = pcg(A,b,1e-10,200,M);
if FLAG==0 
    disp('Iterazioni con precondizionatore'); disp(ITER)
elseif FLAG==1
    disp(' pcg with precond. does not converge in 200 iterations')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%